"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJCallInfo subclass:#AJCdeclCallInfo
	instanceVariableNames:'savedSP'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-StackManagement'
!

!AJCdeclCallInfo methodsFor:'accessing'!

defaultArgumentSize
    ^ 4
! !

!AJCdeclCallInfo methodsFor:'emitting code'!

alignedCleanup

    asm
        mov: savedSP to: asm ESP.
        
    asm releaseTemps: 1 "release our temp afterwards"  
!

emitAlignment
    | instructions |
    
    instructions := asm
        instructionsFor: [ 
            asm
                decorateWith: 'align stack'
                during: [ 
                    savedSP := asm reserveTemp annotation: 'saved SP'.
                    asm mov: asm ESP to: savedSP.
                    stackSize > 0
                        ifTrue: [ asm sub: asm ESP with: (stackSize asUImm annotation: 'stack size') ].
                    asm
                        and: asm ESP with: stackAlignment - 1;
                        neg: asm ESP;
                        add: asm ESP with: savedSP ] ].
    
    asm insert: instructions after: alignInsertionPoint.
    self emitCleanup
!

emitAlignmentIfNeeded
    | alignment |
    
    self needsAlignment
        ifTrue: [ ^ self emitAlignment ].
        
    self emitCleanup
!

emitCleanup
    noCleanup ifTrue: [ ^ self ].
    
    asm insert: 
    (
            asm instructionsFor: [
            self needsAlignment 
                ifTrue: [ self alignedCleanup ]
                ifFalse: [ self normalCleanup ]  			
        ]

    ) after: callCleanup
!

normalCleanup 
    stackSize > 0 ifTrue: [
        asm
            add: asm ESP with: stackSize 
    ]
! !

