"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJBaseReg subclass:#AJRegister
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:'AJConstants'
	category:'AsmJit-Operands'
!

AJRegister comment:'I am an abstract superclass for the standard x86 registers.'
!

!AJRegister methodsFor:'accessing'!

code: aCode
    code := aCode.
    size :=  1 << (( code bitAnd: RegTypeMask ) >> 4).

    "Modified (format): / 15-12-2015 / 23:24:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

influencingRegisters
    self is8
        ifFalse: [ ^ self as8 influencingRegisters ].
    ^ { self as8. self as16. self as32. self as64}
!

size
    ^ 1 << (( code bitAnd: RegTypeMask ) >> 4).

    "Modified (format): / 15-12-2015 / 23:28:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!AJRegister methodsFor:'testing'!

isGeneralPurpose
    ^ false
!

isReg
    ^ true
!

isX86
    "Return whether this register is available in the standard x86 instruction set"

    ^ self requiresRex not & (self index < 8)
! !

