"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJInstruction subclass:#AJReserveTemp
	instanceVariableNames:'operand size'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-StackManagement'
!

AJReserveTemp comment:'note: assembler should set size even before realizing a temp into stack location reference'
!

!AJReserveTemp methodsFor:'accessing'!

name
    ^ name ifNil: [ 'Reserve temp' ]
!

operand
    ^ operands first
!

operand: anObject
    anObject annotation: annotation.  
    operands := Array with: anObject 
!

size
    ^ size
!

size: number
    size := number
!

stackSize
    ^ self size
! !

!AJReserveTemp methodsFor:'converting'!

asAJOperand
    
    ^ operands first
! !

!AJReserveTemp methodsFor:'emitting code'!

emitPushOnStack: asm
    ^ asm push: self
! !

!AJReserveTemp methodsFor:'printing'!

printAsOperandOn: aStream
    
    annotation ifNotNil: [
        aStream nextPut: $"; nextPutAll: annotation asString; nextPut: $"; space
    ].

    operands 
        ifNil: [ ^ aStream nextPutAll: 'aStackTEMP' ].
    self operand printAsOperandOn: aStream.
!

printOn: aStream
    ^ self printSelfOn: aStream  
! !

!AJReserveTemp methodsFor:'testing'!

isMem
    ^ true
!

prohibitsRex
"This test is used to validate if operand(s) is valid.. but reserve temp could not have an operand assigned yet and validation 
can be only performed at instruction analyzis stage (right before emitting the code), but not at instruction creation time"
    self flag: #todo. 
    ^ false
! !

!AJReserveTemp methodsFor:'visitor'!

accept: anObject
    ^ anObject reserveTemp: self
!

processTempsWith: anObject
    anObject reserveTemp: self  
! !

