"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJBaseReg subclass:#AJx87Register
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:'AJConstants'
	category:'AsmJit-x86-Operands'
!

AJx87Register comment:'I am an x87 Floating Point register (ST0 - ST7) used in the FPU stack. 

The lower 64bit of the floating point ST registers are shared with the MMX registers.'
!

!AJx87Register methodsFor:'accessing'!

code: aCode

    code := aCode bitOr: RegX87.
    size := 10.

    "Modified (format): / 15-12-2015 / 23:34:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

influencingRegisters
    "ST registers overlap with the MMX register"
    self shouldBeImplemented.
! !

!AJx87Register methodsFor:'printing'!

descriptionOn: s
    s nextPutAll: 'A floating point register'.
! !

!AJx87Register methodsFor:'testing'!

isGeneralPurpose
    ^ false
!

isRegTypeX87
    ^ true
!

isX86
    ^ true
! !

