"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

LLVMMCJITMemoryManager subclass:#C1LLVMMCJITMemoryManager
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DragonFly-C1'
!

!C1LLVMMCJITMemoryManager primitiveDefinitions!
%{

/*
 * includes, defines, structure definitions
 * and typedefs come here.
 */

#include "../../../stx/librun/mcompiler.h"

%}
! !

!C1LLVMMCJITMemoryManager primitiveFunctions!
%{

/*
 * any local C (helper) functions
 * come here (please, define as static)
 */

uint8_t* callbackAllocateCodeSection(void *Opaque, uintptr_t Size, unsigned Alignment, unsigned SectionID, const char *SectionName) {
    stx_compiled_code_object obj = (stx_compiled_code_object)Opaque;
    stx_compiled_code_object_section sec;

    sec = stxCompiledCodeObjectAllocTextSection(obj, Size, SectionName);
    if (sec) {
        return (uint8_t*)sec->section_addr;
    } else {
	   return NULL;
    }
}

uint8_t* callbackAllocateDataSection(void *Opaque, uintptr_t Size, unsigned Alignment, unsigned SectionID, const char *SectionName, int IsReadOnly) {
    stx_compiled_code_object obj = (stx_compiled_code_object)Opaque;
    stx_compiled_code_object_section sec;

    sec = stxCompiledCodeObjectAllocDataSection(obj, Size, SectionName);
    if (sec) {
        return (uint8_t*)sec->section_addr;
    } else {
       return NULL;
    }
}

int callbackFinalizeMemory(void *Opaque, char **ErrMsg) {
	return 1;
}
void callbackDestroy(void *Opaque) {
	return;
}

%}
! !


!C1LLVMMCJITMemoryManager class methodsFor:'instance creation'!

for: aCompiledCodeObject
    | mm |

    mm := LLVM CreateSimpleMCJITMemoryManager: aCompiledCodeObject
                _: self callbackAllocateCodeSection
                _: self callbackAllocateDataSection
                _: self callbackFinalizeMemory
                _: self callbackDestroy.
    mm changeClassTo: self.
    ^ mm

    "Created: / 07-02-2016 / 13:56:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

new
    self error: 'Use #for: instead'

    "Created: / 08-02-2016 / 14:01:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1LLVMMCJITMemoryManager class methodsFor:'private'!

callbackAllocateCodeSection
%{
    RETURN ( __MKEXTERNALADDRESS (callbackAllocateCodeSection ) );
%}.
    self primitiveFailed.

    "Created: / 07-02-2016 / 10:11:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

callbackAllocateDataSection
%{
    RETURN ( __MKEXTERNALADDRESS (callbackAllocateDataSection ) );
%}.
    self primitiveFailed.


    "Created: / 07-02-2016 / 10:11:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

callbackDestroy
%{
    RETURN ( __MKEXTERNALADDRESS (callbackDestroy ) );
%}.
    self primitiveFailed.

    "Created: / 07-02-2016 / 10:11:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

callbackFinalizeMemory
%{
    RETURN ( __MKEXTERNALADDRESS (callbackFinalizeMemory ) );
%}.
    self primitiveFailed.

    "Created: / 07-02-2016 / 10:11:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1LLVMMCJITMemoryManager class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

